import java.io.*;
import java.util.*;

import javax.swing.JFileChooser;
public class CPUMain {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
			System.out.println("NERD16 CPU Emulator 1.0.0");
			@SuppressWarnings("unused")
			int prl = 256;
			int drl = 8;
			byte[] ram = new byte[1024];
			byte[] tram = new byte[drl];
			System.out.println((ram.length+drl+prl)+" Bytes Free...");
			Scanner sc = new Scanner(System.in);
			ram[0] = 0;
			ram[1] = 1;
			ram[2] = 2;
			ram[3] = 3;
			ram[4] = 4;
			ram[5] = 5;
			ram[6] = 6;
			ram[7] = 7;
			ram[8] = 8;
			ram[9] = 9;
			byte areg = 0;
			byte breg = 0;
			byte mreg = 0;
			int i = 0;
			int addr;
			try
			{
				File fo = new File(sc.nextLine());
				FileReader reader = new FileReader(fo);
				BufferedReader breader = new BufferedReader(reader);
				String line = null;
				Boolean hlted = false;
				while(((line = breader.readLine()) != null))
				{
					addr = -1;
					if(!hlted)
					{
						System.out.print("0x"+Integer.toHexString(i)+": "+line+" ");
						
						switch(line)
						{
						case "0":
							System.out.println("NOP");
							i += 1;
							break;
						
						case "1":
							System.out.println("HLT");
							i += 1;
							hlted = true;
							break;
							
						case "2":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDA "+addr);
							areg = ram[addr-255];
							i += 2;
							break;
							
						case "3":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STA "+addr);
							ram[addr-255] = areg;
							i += 2;
							break;
							
						case "4":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDB "+addr);
							breg = ram[addr-255];
							i += 2;
							break;
							
						case "5":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STB "+addr);
							ram[addr-255] = breg;
							i += 2;
							break;
							
						case "6":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDM "+addr);
							mreg = ram[addr-255];
							i += 2;
							break;
							
						case "7":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STM "+addr);
							ram[addr-255] = mreg;
							i += 2;
							break;
							
						case "8":
							System.out.println("ADD");
							mreg += areg;
							i += 1;
							break;
							
						case "9":
							System.out.println("SUB");
							mreg -= areg;
							i += 1;
							break;
							
						case "A":
							System.out.println("DIV");
							mreg /= areg;
							i += 1;
							break;
							
						case "B":
							System.out.println("MUL");
							mreg *= areg;
							i += 1;
							break;
							
						case "C":
							System.out.println("Swapping A ("+areg+") and B ("+breg+")");
							byte t = 0;
							t = areg;
							areg = breg;
							breg = t;
							i += 1;
							break;
							
						case "D":
							System.out.print("DSP ");
							System.out.print(ram[247]+"|");
							System.out.print(ram[248]+"|");
							System.out.print(ram[249]+"|");
							System.out.print(ram[250]+"|");
							System.out.print(ram[251]+"|");
							System.out.print(ram[252]+"|");
							System.out.print(ram[253]+"|");
							System.out.print(ram[254]+"|");
							System.out.println(ram[255]);
							i += 1;
							break;
							
						case "E":
							System.out.println("INC");
							breg += 1;
							i += 1;
							break;
							
						case "F":
							System.out.println("DEC");
							breg -= 1;
							i += 1;
						}
						
						System.out.println("A: "+areg);
						System.out.println("B: "+breg);
						System.out.println("M: "+mreg);
						
						
					}
				}
				breader.close();
				
				System.out.println("------------------RAM DUMP------------------");
				int z = 0;
				while(z <= ram.length-1)
				{
					System.out.println("0x"+Integer.toHexString(z)+": "+ram[z]);
					z += 1;
				}
				
				System.out.print("Press Enter To Quit...");
				sc.nextLine();
			} catch(Exception ex) {
				System.out.println(ex);
			}
			
			
	}
	

}
